
{$APPTYPE GUI}{$MODE DELPHI}

program DemoSimplePlanet;

uses
  SysUtils,windows,math,gl,glu,GraphOGL,GOGL_SimplePlanet,GOGL_CloudsGFX;

//const
 
//type
  
var 
  planet:array[0..3]of TAdvacedPlanet;
  TexCloud:array[0..1]of gluint;
  time:glFloat;
  SelPlanet:integer = 0;
  SelView:integer = 2;
  
   
//{$R *.rc}
//{$R *.res}   


function RockyPlanet(v,d,min,max:glfloat):TGLRGB2;  
var 
  c:TGLRGB2 = (r:1;g:1;b:1);
  c1,c2,c3:TGLRGB2;
  ratio,mid:glfloat;
begin
  c1:=glColor(55/255,55/255,45/255);
  c2:=glColor(196/255,132/255,68/255);
  c3:=glColor(250/255,250/255,250/255);
		  
  ratio:=0.4;
  mid:=min+ratio*d;
  if v<mid then
  begin
    c.r:=(c2.r-c1.r)*(v-min)/(ratio*d)+c1.r;
    c.g:=(c2.g-c1.g)*(v-min)/(ratio*d)+c1.g;
    c.b:=(c2.b-c1.b)*(v-min)/(ratio*d)+c1.b;
  end else c:=glColor((c3.r-c2.r)*(v-mid)/((1-ratio)*d)+c2.r,(c3.g-c2.g)*(v-mid)/((1-ratio)*d)+c2.g,(c3.b-c2.b)*(v-mid)/((1-ratio)*d)+c2.b);    
  
  result:=c;
end;


function GreenPlanet(v,d,min,max:glfloat):TGLRGB2;  
var 
  c:TGLRGB2 = (r:1;g:1;b:1);
  c1,c2,c3:TGLRGB2;
  ratio,mid:glfloat;
begin
  c1:=glColor(196/255,132/255,68/255);
  c2:=glColor(70/255,112/255,24/255);
  c3:=glColor(255/255,255/255,255/255);
		  
  ratio:=0.4;
  mid:=min+ratio*d;
  if v<mid then
  begin
    c.r:=(c2.r-c1.r)*(v-min)/(ratio*d)+c1.r;
    c.g:=(c2.g-c1.g)*(v-min)/(ratio*d)+c1.g;
    c.b:=(c2.b-c1.b)*(v-min)/(ratio*d)+c1.b;
  end else c:=glColor((c3.r-c2.r)*(v-mid)/((1-ratio)*d)+c2.r,(c3.g-c2.g)*(v-mid)/((1-ratio)*d)+c2.g,(c3.b-c2.b)*(v-mid)/((1-ratio)*d)+c2.b);    
  
  result:=c;
end;


function Star(v,d,min,max:glfloat):TGLRGB2;  
var 
  c:TGLRGB2 = (r:1;g:1;b:1);
begin
  c:=glColor(1,(v-min)/d,0);
  result:=c;  
end;


procedure OpenGL_CreateList();

procedure OpenGL_Texture();
begin    
  
  
end;
begin 

  OpenGL_Texture();
  
  GenSphere(planet[0],6,1);
  SetPlanet(planet[0],RockyPlanet,8,0,6, 250, 1);
  
  GenSphere(planet[1],6,1);
  SetPlanet(planet[1],GreenPlanet,8,0,6, 250, 1); 
  
  GenSphere(planet[2],6,1);
  SetPlanet(planet[2],Star,8,0,1, 250, 1);   
  
  GenSphere(planet[3],6,1);
  SetPlanet(planet[3],RockyPlanet,7,0.7,7, 250, 1);     
  
  GenTexHighCloud2D(256,2,150,150,150,1,TexCloud[0]); 
  GenTexHighCloud2D(256,2,150,150,150,1,TexCloud[1]); 
  
end;


procedure OpenGL_Draw();

procedure OpenGL_Draw2D();
begin
 
  OpenGL_I2D(0,0,0,0);       // inizializza la grafica 2D 
  
  OpenGL_Init(100,0,0,0,0);  // reimposta la grafica 3D
  
end;
procedure OpenGL_Mouse2D();
begin
  
end;
procedure OpenGL_Keyboard();
begin
  
  if SetglKey('I')then SelView:=0;
  if SetglKey('T')then SelView:=1;
  if SetglKey('N')then SelView:=2; 

  if SetglKey('1')then SelPlanet:=0;   
  if SetglKey('2')then SelPlanet:=1; 
  if SetglKey('3')then SelPlanet:=2; 
  if SetglKey('4')then SelPlanet:=3; 
  
end;
begin

  glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
  glLoadIdentity();
 
  OpenGL_Draw2D();               // carica gli elementi per la grafica 2d 
  OpenGL_Mouse2D();              // carica i comandi del mause per la grafica 2d
  OpenGL_Keyboard();             // carica i comandi della tastiera
  
  glTranslatef(0,0,-30);        // regola l'inquadratura degli elementi nello schermo
  glRotatef(0,1,0,0); 
  
  SetglMouseMove(GL_M0,2);    
  
  PutglPointLight(GL_LIGHT0,0, -10,0,10, 0.1); 

  time:=time+0.0025;
 
  case SelPlanet of
    0: begin
         TextureOFF;  
         GenPlanet(planet[0],SelView);
         AddOcean(planet[0],1, 0.4,0.4,1);
         TextureON;
         AddClouds3D(planet[0],1.6,0.5, 2, time,TexCloud[0]);
       end;
    1: begin
         TextureOFF;  
         GenPlanet(planet[1],SelView);
         AddOcean(planet[1],1, 0.4,0.4,1);
         TextureON;
         AddClouds3D(planet[1],1.6,0.5, 2, time,TexCloud[1]);
       end;	 
    2: begin
         TextureOFF;  
         GenPlanet(planet[2],SelView);
         AddOcean(planet[2],40, 0.8,0.4,0);
         TextureON;
       end;	
    3: begin
         TextureOFF;  
         GenPlanet(planet[3],SelView);
         TextureON;
       end;		   
  end;
  
end;

// inizio del programma
begin

 if MessageBox(0,'Settare lo schermo intero?  ', 'Video!',MB_YESNO OR MB_ICONQUESTION) = IDNO 
  then fullscreen := false else fullscreen := true;
  
 OGLWindowSetting(ARROW,'',GENERIC,'');
 CreateOGLWindow('Generazione di un pianeta - 1/4 selezione elemento - vista: I infrarosso | T termica | N normale', 800, 600, 32, fullscreen);// si possono usare anche dei rapporti diversi da 4/3 o 16/9
 OpenGL_Init(100,0,0,0,0);			  // inizializza la grafica OpenGL(consente d'impostare il colore di sfondo e la profondit della visuale) 
 SetglRefractive();                         // imposta la rifrazione ambientale ed elimina le facce interne
 SetglLight(GL_LIGHT0,0.0,0.0,0.0,0.1);     // imposta la luce ambientale
 OpenGL_CreateList();                       // carica le liste degli oggetti (modelli composti)

 // impostare qui i valori delle variabili   

 REPEAT				     // inizio del ciclo principale

 glCLEAR(GL_COLOR_BUFFER_BIT);
 Setglmsg();

 OpenGL_Draw();             // carica gli elementi che devono essere un aggiornati sullo schermo 
 SwapBuffers(dcWindow);	    // abilita la visualizzazione grafica OpenGL

 // inserire qui eventuali dati aggiuntivi

UNTIL active = false;		// fine del ciclo principale (premere ESC per uscire)

 DeleteOGLWindow();		    // chiude la finestra
end.
